<script
src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBQ50psAEujNA_LwZ92MCMkspX4v_C5X9Q&callback=initMap&v=weekly"
defer>
</script>
<style>
  #map {
    height: 600px;
    /* The height is 400 pixels */
    width: 100%;
    /* The width is the width of the web page */
  }
</style>
<script>
  let map;
  function initMap() {

    var latt = <%= @location.lat %>;
    var longg = <%= @location.long %>;
    var myLatlng = new google.maps.LatLng(latt,longg);
    var mapOptions = {
      zoom: 15,
      center: myLatlng
    }
    map = new google.maps.Map(document.getElementById("map"), mapOptions);
  }

</script>

<%# <%= link_to 'Retour', locations_path, class:"btn btn-danger", style:"color:white" %>
<div class="row mt-4">
  <h2><%= @location.titre %></h2>
</div>
<div class="row" >
  <div class="col-7">
    <p>
      <i class="fas fa-star" style="color:red;backgorund-color:red;"></i> <% if @location.avg_rate == 11 %>-<% else %><%= @location.avg_rate %><% end %>
      ·
      <%= @location_avis.size %><% if @location_avis.size == 1 %> commentaire<% else %> commentaires<% end %>
      ·
      <%= @location.address %>, <%= @location.street %>, <%= @location.zip %>, <%= @location.city %>
    </p>
  </div>
  <div class="col">

    <%= render 'favoris/form', favori: @favori, location: @location %>

    <% if current_user.id == @location.user_id %>
    <%= link_to 'Ajouter un équipement', new_equipement_path(@location), class: "btn btn-primary", style: "color: white;float: right;" %>
    <%= link_to 'Éditer', edit_location_path(@location), class: "btn btn-info", style: "color: white;float: right;" %>
    <%= link_to 'Supprimer', @location, method: :delete, data: { confirm: 'Êtes-vous sûr ?' }, class: "btn btn-danger ", style: "color: white;float: right;" %>
    <% end %>

    </div>
  </div><br>
  <div class="row">
    <div class="col-8">
      <img src="<%= @location.photos %>" class="img-fluid rounded" alt="LocationExemple" >
    </div>
    <div class="col shadow-sm p-4  bg-white rounded rounded border " align="center">
      <% if current_user.id == @location.user_id %>
        <% if @location_reservations.count == 0 %>
            <span class="">Aucune réservation pour le moment :(</span>
        <% else %>
          <h3>Nombre de réservations</h3>
          <span>Total : <%= @location_reservations.count %></span><br>
          <a href="#gestion_reservation" class='btn btn-warning btn-sm' style="color: white" >Montrer les réservations</a>

        <% end %>
      <% else %>
        <p style="font-size: 1em;"><b><%= @location.price %> €</b> /nuit . Taxe séjour : <b><%= @location.taxesjr %> €</b></p><br>
        <div class="d-flex justify-content-around">
          <%= render 'reservations/form', reservation: @reservation, location: @location, class:""%>
        </div>
      <% end %>
    </div>
  </div>



<div class="row mt-2">
  <div class="col-12">
    <h4><%= @location.v_type %> · Hôte : <%= @location_user.email %></h4>
    <p>
      Nombre de chambre : <%= @location.nbChambre %>· Nombre de couchage : <%= @location.nbCouchage %>
    </p>

    <hr>
    <h4>Ce que propose ce logement : </h4>

    <!-- Equipements -->
    <div class="card-deck mt-4">

      <% @equipement_categorie_list = [] %>
      <% @equipements.each do |equipement| %>
        <% @equipement_categorie_list << equipement.categories_id %>
      <% end %>

      <% @categories.each do |categorie| %>
        <% if @equipement_categorie_list.include? categorie.id %>
          <div class="row">
            <h5><%= categorie.nom %></h5>
            <% @equipements.each do |equipement| %>
              <% if categorie.id == equipement.categories_id %>
                <div class="card m-3" style="width: auto">
                  <div class="card-body">
                    <div class="row">
                      <div class="col">
                        <h5 class="card-title"><%= equipement.nom %></h5>
                      </div>
                      <div class="col-3" style="width: auto">
                        <%= link_to equipement, class: 'btn btn-danger ',:style => "color: white," , :method => :delete do %>  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-trash" viewBox="0 0 16 16" color=white>
                            <path d="M5.5 5.5A.5.5 0 0 1 6 6v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm2.5 0a.5.5 0 0 1 .5.5v6a.5.5 0 0 1-1 0V6a.5.5 0 0 1 .5-.5zm3 .5a.5.5 0 0 0-1 0v6a.5.5 0 0 0 1 0V6z"/>
                            <path fill-rule="evenodd" d="M14.5 3a1 1 0 0 1-1 1H13v9a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2V4h-.5a1 1 0 0 1-1-1V2a1 1 0 0 1 1-1H6a1 1 0 0 1 1-1h2a1 1 0 0 1 1 1h3.5a1 1 0 0 1 1 1v1zM4.118 4 4 4.059V13a1 1 0 0 0 1 1h6a1 1 0 0 0 1-1V4.059L11.882 4H4.118zM2.5 3V2h11v1h-11z"/>
                          </svg><% end %>
                      </div>
                    </div>
                  </div>
                </div>
              <% end %>
            <% end %>
          </div>
        <% end %>
      <% end %>
    </div>



    <hr>
    <h4>Description : </h4>
    <p><%= @location.desc %></p>
    <hr>
    <h4>Coordonnées : </h4>
    <p>
      Latitude : <%= @location.lat %> | Longitude : <%= @location.long %><br>
      <%= @location.address %>, <%= @location.street %>, <%= @location.zip %>, <%= @location.city %>
    </p>
    <div id="map"></div>
  </div>
</div>


<div class="row">
  <div class="col-12"><br>


    <h4><i class="fas fa-star" style="color:red;backgorund-color:red;"></i> <% if @location.avg_rate == 11 %>-<% else %><%= @location.avg_rate %><% end %>
      ·
      <%= @location_avis.size %><% if @location_avis.size == 1 %> commentaire<% else %> commentaires<% end %></h4>


      <div class="card-deck mt-4">
        <div class="row">
          <% @location_avis.each do |avis| %>
          <div class="col" >
            <div class="card"  style="width: 18rem">
              <div class="card-body">
                <% @users.each do |user| %>
                  <% if avis.user_id == user.id %>
                    <h5 class="card-title" style="display: block; overflow: hidden; white-space: nowrap; text-overflow: ellipsis;">Avis de <%= user.email %>  </h5>
                  <% end %>
                <% end %>
                
                <p class="card-text"><%= avis.comment %> </p>
              </div>
              <div class="card-footer">
                <small class="text-muted ">Note : <%= avis.note %></small>
              </div>
            </div>
            <br>
          </div>
          <% end %>
        </div>
      </div>
      <%= link_to ' Ajouter un comentaire', new_avi_path(@location), style: "color: white", class: "btn btn-success" %>

    </div>
  </div>
  <br>


  <% if current_user.id == @location.user_id %>
  <h4 id="gestion_reservation">Gestion des réservations</h4>
  <table class="table">
    <thead>
      <tr>
        <th scope="col">Date d'arrivée</th>
        <th scope="col">Date de départ</th>
        <th scope="col">Nombre de personnes</th>
        <th scope="col">Prix</th>
        <th scope="col">Statut de la réservation</th>
        <th scope="col" colspan="3">Actions</th>
      </tr>
    </thead>

      <% if @location_reservations.count == 0 %>
          <span class="">Aucune réservation pour le moment :(</span>
      <% else %>
        <% @location_reservations.each do |location_reservation| %>

          <tr>
            <td><%= location_reservation.datedeb.strftime("%d/%m/%Y") %></td>
            <td><%= location_reservation.datefin.strftime("%d/%m/%Y") %></td>
            <td><%= location_reservation.nbpersonnes %></td>
            <td><%= location_reservation.price %> €</td>
            <td>
              <% if location_reservation.status == "En attente" %>
                <span class="badge bg-warning text-dark">En attente</span>
              <% elsif location_reservation.status == "Refusée" %>
                <span class="badge bg-danger">Refusée</span>
              <% elsif location_reservation.status == "Acceptée" %>
                <span class="badge bg-primary">Acceptée</span>
              <% elsif location_reservation.status == "Payée" %>
                <span class="badge bg-success">Payée</span>
              <% elsif location_reservation.status == "Terminée" %>
                <span class="badge bg-dark">Terminée</span>
              <% end %>
            </td>
            <td><%= link_to 'Afficher', location_reservation, class: 'btn btn-primary btn-sm', :style => "color: white" %></td>
            <td><%= link_to 'Editer', edit_reservation_path(location_reservation), class: 'btn btn-warning btn-sm', :style => "color: white" %></td>
            <td><%= link_to 'Supprimer', location_reservation, method: :delete, data: { confirm: 'Êtes vous sûr ?' }, class: 'btn btn-danger btn-sm', :style => "color: white" %></td>
          </tr>
        <% end %>
      <% end %>
  </table>
<% end %>



  <script>
    function addMarker(){

      var titre = "<%= @location.titre %>";
      const photoLoca = "<%= @location.photos %>";
      const typeLoca = "<%= @location.v_type %>";
      const cityLoca = "<%= @location.city %>";
      const zipLoca = "<%= @location.zip %>";
      const priceLoca = "<%= @location.price %>";
      const rateLoca = "<%= @location.avg_rate %>";

      const contentString =
      '<div class="card-deck mt-4" style="overflow: hidden">' +
        '<div class="row">' +
          '<div class="col">' +
            '<div class="card" style="width: 18rem" >' +
              '<img class="card-img-top" src="'+photoLoca+'" alt="Location image" style="width: 18rem; height: 10rem">' +
              '<div class="card-body">' +
                '<h5 class="card-title" style="display: block; overflow: hidden; white-space: nowrap; text-overflow: ellipsis;">'+titre+' | '+typeLoca+'</h5>' +
                '<p class="card-text" style="display: block; overflow: hidden; white-space: nowrap; text-overflow: ellipsis;">'+cityLoca+' '+zipLoca+'</p>' +
              '</div>' +
              '<div class="card-footer">' +
                '<small class="text-muted ">'+priceLoca+'€/nuit</small>' +
                '<small class="text-muted"> | Noté '+rateLoca+'/10</small>' +
              '</div>' +
            '</div>' +
            '<br>' +
            '</div>' +
            '</div>' +
            '</div>';

                  const infowindow = new google.maps.InfoWindow({
                    content: contentString,
                  });

                  var lat = <%= @location.lat %>;
                  var long = <%= @location.long %>;

                  var marker = new google.maps.Marker({
                    position: new google.maps.LatLng(lat,long),
                    title: titre,
                    map
                  });

                  marker.addListener("click", () => {
                    infowindow.open({
                      anchor: marker,
                      map,
                      shouldFocus: false,
                    });
                  });

                }
              </script>


              <script>
                document.addEventListener('DOMContentLoaded', () => {
                  addMarker();
                });
              </script>
